#include <iostream>
#include <string>
#include <vector>
#include "Component.h"
#include "Group.h"
#include "Person.h"

int main()
{
    Component *science   = new Group("science");
    Component *physics   = new Group("physics");
    Component *biology   = new Group("biology");
    Component *chemistry = new Group("chemistry");

    Component *classic = new Group("classic");
    Component *quantum = new Group("quantum");

    Component *tom  = new Person("Tom");
    Component *dick = new Person("Dick");
    Component *jane = new Person("Jane");

    // Add groups.
    science->add(physics);
    science->add(biology);
    science->add(chemistry);

    // Add persons.
    quantum->add(tom);
    quantum->add(jane);
    biology->add(dick);

    // Add groups.
    physics->add(classic);
    physics->add(quantum);

    cout << "ENTIRE TREE:" << endl;
    science->print();

    cout << endl << "ONE GROUP:" << endl;
    quantum->print();

    cout << endl << "ONE PERSON:" << endl;
    jane->print();

    return 0;
}
